var md = {};
md.fibu = {};

// Merker für letztes Konto
md.fibu.lastKonto = null;
md.fibu.lastYear = null;
md.fibu.lastMonth = null;

// App-Start
$(document).ready(function() {
	// Eenthandler für Buttons anlegen
	md.fibu.createButtonHandlers();
	// Übersicht anzeigen
	md.fibu.getOverview();
	// Kontenliste laden
	md.fibu.refreshKonten();
});

// Tabellenkopf für Konten zusammenbauen
md.fibu.addTableHeader = function(table, konto, year, month) {

	var thead = document.createElement("thead");

		// Monats-Navigation
		var tr_mon = document.createElement("tr");
		
			var str_mon = "" + month;
			var pad = "00";
			str_mon = pad.substring(0, pad.length - str_mon.length) + str_mon;
		
			var th_mon = document.createElement("th");
			th_mon.colSpan = 7;
			
				// Vormonat
				var previousYear = year;
				var previousMonth = month - 1;
				if(previousMonth == 0) {
					previousYear -= 1;
					previousMonth = 12;
				}
				
				var a1 = document.createElement("a");
				a1.setAttribute("data-konto", konto);
				a1.setAttribute("data-year", previousYear);
				a1.setAttribute("data-month", previousMonth);
				a1.addEventListener("click", function(e) {
						md.fibu.getKontoDetails(e.target.getAttribute("data-konto"), e.target.getAttribute("data-year"), e.target.getAttribute("data-month"));
					}, false
				);
				a1.title = "Vormonat";
				a1.innerHTML = "&lt;&nbsp;";
				th_mon.appendChild(a1);
			
				// Anzeige aktueller Monat
				var span = document.createElement("span");
				span.innerHTML = year + "-" + str_mon;
				th_mon.appendChild(span);
			
				// Nächster Monat
				var nextYear = year;
				var nextMonth = month + 1;
				if(nextMonth == 13) {
					nextYear += 1;
					nextMonth = 1;
				}
				
				var a2 = document.createElement("a");
				a2.setAttribute("data-konto", konto);
				a2.setAttribute("data-year", nextYear);
				a2.setAttribute("data-month", nextMonth);
				a2.addEventListener("click", function(e) {
						md.fibu.getKontoDetails(e.target.getAttribute("data-konto"), e.target.getAttribute("data-year"), e.target.getAttribute("data-month"));
					}, false
				);
				a2.title = "N&auml;chster Monat";
				a2.innerHTML = "&nbsp;&gt;";
				th_mon.appendChild(a2);
				
			tr_mon.appendChild(th_mon);
		
		thead.appendChild(tr_mon);

		// Kopfzeilen
		var tr = document.createElement("tr");

			var th1 = document.createElement("th");
			th1.innerHTML = "ID";
			th1.style.width = "150px";
			tr.appendChild(th1);

			var th2 = document.createElement("th");
			th2.innerHTML = "Datum/Uhrzeit";
			th2.style.width = "150px";
			tr.appendChild(th2);

			var th3 = document.createElement("th");
			th3.innerHTML = "Beschreibung";
			tr.appendChild(th3);

			var th4 = document.createElement("th");
			th4.innerHTML = "Betrag";
			th4.style.width = "150px";
			tr.appendChild(th4);

			var th5 = document.createElement("th");
			th5.innerHTML = "Verweis";
			th5.style.width = "150px";
			tr.appendChild(th5);

			var th6 = document.createElement("th");
			th6.innerHTML = "Saldo";
			th6.style.width = "150px";
			tr.appendChild(th6);

			var th7 = document.createElement("th");
			th7.innerHTML = "Optionen";
			th7.style.width = "150px";
			tr.appendChild(th7);
		
		thead.appendChild(tr);
		
	table.appendChild(thead);
}
md.fibu.addTableField = function(tr, value, align) {
	var td = document.createElement("td");
	td.innerHTML = value;
	td.style.textAlign = align;
	tr.appendChild(td);
}
md.fibu.addDateTimeField = function(tr, datum, zeit) {
	var td = document.createElement("td");
	td.innerHTML = datum.substr(8, 2) + "." + datum.substr(5, 2) + "." + datum.substr(0, 4) + " " + zeit.substr(0,5) + " Uhr";
	td.style.textAlign = "left";
	tr.appendChild(td);
}
md.fibu.addNameField = function(tr, name, description, kategorie) {
	var td = document.createElement("td");
	td.title = "Kategorie: " + kategorie + "\nDetails:\n" + description;
	
		var span = document.createElement("span");
		span.innerHTML = name;
		td.appendChild(span);
	
	td.style.textAlign = "left"
	tr.appendChild(td);
}
md.fibu.addOptionField = function(tr, id) {
	var td = document.createElement("td");
		
		var img_edit = document.createElement("img");
		img_edit.src = md.getImgPath() + "edit.svg";
		img_edit.title = "Bearbeiten";
		img_edit.className = "util_icon";
		img_edit.setAttribute("data-buchung", id);
		img_edit.addEventListener("click", function(e) {
				md.fibu.editBuchung(e.target.getAttribute("data-buchung"));
			}, false
		);
		td.appendChild(img_edit);
		
		var img_del = document.createElement("img");
		img_del.src = md.getImgPath() + "delete.svg";
		img_del.title = "Löschen";
		img_del.className = "util_icon";
		img_del.setAttribute("data-buchung", id);
		img_del.addEventListener("click", function(e) {
				md.fibu.deleteBuchung(e.target.getAttribute("data-buchung"));
			}, false
		);
		td.appendChild(img_del);
	
	td.style.textAlign = "center";
	tr.appendChild(td);
}
md.fibu.addConnectionField = function(tr, id, connection, created_by) {
	var td = document.createElement("td");
	
		if(typeof(connection.id) != "undefined") {
			var a = document.createElement("a");
			a.innerHTML = "ID " + connection.id + " @ " + connection.konto_name;
			a.className = "connection";
			a.title = "Verweis folgen";
			a.addEventListener("click", function(e) {
				md.fibu.getKontoDetails(connection.konto, connection.year, connection.month);
				}, false
			);
			td.appendChild(a);
			
			var img_edit = document.createElement("img");
			img_edit.src = md.getImgPath() + "delete.svg";
			img_edit.title = "Verweis löschen";
			img_edit.className = "util_icon";
			img_edit.setAttribute("data-buchung", id);
			img_edit.addEventListener("click", function(e) {
				md.fibu.deleteConnection(e.target.getAttribute("data-buchung"));
				}, false
			);
			td.appendChild(img_edit);
		} else {
			var img_add = document.createElement("img");
			img_add.src = md.getImgPath() + "add.svg";
			img_add.title = "Verweis hinzufügen";
			img_add.className = "util_icon";
			img_add.setAttribute("data-buchung", id);
			img_add.addEventListener("click", function(e) {
				md.fibu.addConnection(e.target.getAttribute("data-buchung"));
				}, false
			);
			td.appendChild(img_add);
		}
		
		if(created_by.length > 0) {
			var span = document.createElement("span");
			span.innerHTML = "&nbsp;(by " + created_by + ")";
			td.appendChild(span);
		}
	
	td.style.textAlign = "left";
	tr.appendChild(td);
}

// Stellt eine Zahl als Euro-Betrag dar (3,00 €)
md.asEuro = function(num) {
	return md.asMoney(num) + " &euro;";
}
// Stellt eine Zahl als Betrag dar (3,00)
md.asMoney = function(num) {
	return parseFloat(num).numberFormat(2, ",", ".");
}
// Stellt eine Zahl als farbig markierten Euro-Betrag dar
md.asColoredEuro = function(num) {
	var color = "neu";
	if(parseFloat(num) < 0) {
		color = "neg";
	} else if(parseFloat(num) > 0) {
		color = "pos"
	}
	return "<span class=\"money_"+color+"\">" + md.asEuro(num) + "</font>";
}

Number.prototype.numberFormat = function(decimals, dec_point, thousands_sep) {
    dec_point = typeof dec_point !== 'undefined' ? dec_point : '.';
    thousands_sep = typeof thousands_sep !== 'undefined' ? thousands_sep : ',';

    var parts = this.toFixed(decimals).split('.');
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, thousands_sep);

    return parts.join(dec_point);
}

// Legt für alle Buttons die Eventhandler an
md.fibu.createButtonHandlers = function() {
	// Übersicht-Button im Menü
	$("#overview").click(function() {
		md.fibu.getOverview();
	});
	// Neue buchung im Menü
	$("#new-buchung").click(function() {
		md.fibu.newBuchung();
	});
	
	// Buttons im Dialog "Neue Buchung"
	$("#new_buchung_dialog_close").click(function() {
		$("#new_buchung_dialog").css("display", "none");
	});
	$("#submitNewBuchung").click(function() {
		md.fibu.newBuchungSave();
	});
	$("#cancelNewBuchung").click(function() {
		$("#new_buchung_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Buchung löschen"
	$("#delete_buchung_dialog_close").click(function() {
		$("#delete_buchung_dialog").css("display", "none");
	});
	$("#submitDeleteBuchung").click(function() {
		md.fibu.deleteBuchungSubmit();
	});
	$("#cancelDeleteBuchung").click(function() {
		$("#delete_buchung_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Buchung bearbeiten"
	$("#edit_buchung_dialog_close").click(function() {
		$("#edit_buchung_dialog").css("display", "none");
	});
	$("#submitEditBuchung").click(function() {
		md.fibu.editBuchungSubmit();
	});
	$("#cancelEditBuchung").click(function() {
		$("#edit_buchung_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Verweis löschen"
	$("#delete_connection_dialog_close").click(function() {
		$("#delete_connection_dialog").css("display", "none");
	});
	$("#submitDeleteConnection").click(function() {
		md.fibu.deleteConnectionSubmit();
	});
	$("#cancelDeleteConnection").click(function() {
		$("#delete_connection_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Neuer verweis"
	$("#new_connection_dialog_close").click(function() {
		$("#new_connection_dialog").css("display", "none");
	});
	$("#submitNewConnection").click(function() {
		md.fibu.newConnectionSubmit();
	});
	$("#cancelNewConnection").click(function() {
		$("#new_connection_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Konto löschen"
	$("#deleteKonto").click(function() {
		md.fibu.deleteKonto();
	});
	$("#delete_konto_dialog_close").click(function() {
		$("#delete_konto_dialog").css("display", "none");
	});
	$("#submitDeleteKonto").click(function() {
		md.fibu.deleteKontoSubmit();
	});
	$("#cancelDeleteKonto").click(function() {
		$("#delete_konto_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Neues Konto"
	$("#newKonto").click(function() {
		md.fibu.newKonto();
	});
	$("#new_konto_dialog_close").click(function() {
		$("#new_konto_dialog").css("display", "none");
	});
	$("#submitNewKonto").click(function() {
		md.fibu.newKontoSubmit();
	});
	$("#cancelNewKonto").click(function() {
		$("#new_konto_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Konto bearbeiten"
	$("#editKonto").click(function() {
		md.fibu.editKonto();
	});
	$("#edit_konto_dialog_close").click(function() {
		$("#edit_konto_dialog").css("display", "none");
	});
	$("#submitEditKonto").click(function() {
		md.fibu.editKontoSubmit();
	});
	$("#cancelEditKonto").click(function() {
		$("#edit_konto_dialog").css("display", "none");
	});
	$("#edit_konto_id").change(function() {
		if($("#edit_konto_id")[0].value == 0) {
			$(".edit_konto_details").attr('readonly', true);
		} else {
			md.fibu.getEditKonto();
		}
	});
	
	// Buttons im Dialog "Kategorie löschen"
	$("#deleteKategorie").click(function() {
		md.fibu.deleteKategorie();
	});
	$("#delete_kategorie_dialog_close").click(function() {
		$("#delete_kategorie_dialog").css("display", "none");
	});
	$("#submitDeleteKategorie").click(function() {
		md.fibu.deleteKategorieSubmit();
	});
	$("#cancelDeleteKategorie").click(function() {
		$("#delete_kategorie_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Neue Kategorie"
	$("#newKategorie").click(function() {
		md.fibu.newKategorie();
	});
	$("#new_kategorie_dialog_close").click(function() {
		$("#new_kategorie_dialog").css("display", "none");
	});
	$("#submitNewKategorie").click(function() {
		md.fibu.newKategorieSubmit();
	});
	$("#cancelNewKategorie").click(function() {
		$("#new_kategorie_dialog").css("display", "none");
	});
	
	// Buttons im Dialog "Kategorie bearbeiten"
	$("#editKategorie").click(function() {
		md.fibu.editKategorie();
	});
	$("#edit_kategorie_dialog_close").click(function() {
		$("#edit_kategorie_dialog").css("display", "none");
	});
	$("#submitEditKategorie").click(function() {
		md.fibu.editKategorieSubmit();
	});
	$("#cancelEditKategorie").click(function() {
		$("#edit_kategorie_dialog").css("display", "none");
	});
	$("#edit_kategorie_id").change(function() {
		if($("#edit_kategorie_id")[0].value == 0) {
			$(".edit_kategorie_details").attr('readonly', true);
		} else {
			md.fibu.getEditKategorie();
		}
	});
	
	// Button für Konto-Auswertung
	$("#showAuswertung").click(function() {
		md.fibu.showAuswertung();
	});
	// Button für Kategorie-Auswertung
	$("#showAuswertungKat").click(function() {
		md.fibu.showAuswertungKat();
	});
}

// Ansicht neu laden
md.fibu.refresh = function() {
	md.fibu.refreshKonten();
	if(md.fibu.lastKonto != null) {
		md.fibu.getKontoDetails(md.fibu.lastKonto, md.fibu.lastYear, md.fibu.lastMonth);
	}
}

// Fügt eine Liste der Konten als Optionen an ein Select an
md.fibu.appendKontoOptions = function(select_id, className) {
	$("."+className).remove();
	$.each($(".konto"), function(i, val) {
		var option = document.createElement("option");
		var id = val.childNodes[0].getAttribute("data-id");
		var name = val.childNodes[0].childNodes[0].innerHTML;
		option.value = id;
		option.innerHTML = name;
		option.className = className;
		$("#"+select_id)[0].appendChild(option);
	});
}

// Cache für die Kategorien
md.fibu.katCache = null;

// Fügt eine Liste der Kategorien als Optionen an ein Select an
md.fibu.appendKategorieOptions = function(select_id, className) {
	$("."+className).remove();
	
	var result = null;
	if(md.fibu.katCache == null) {
		// Url basteln
		var url = "ajax/get_kategorien.php";
		
		// Übertragen
		result = md.getValJsonObj(url);
		if(result === false) {
			return;
		}
		
		// Ergebnis cachen
		md.fibu.katCache = result;
	} else {
		// Aus Cache laden
		result = md.fibu.katCache;
	}
	
	for(var i = 0; i < result.data.kategorien.length; i++) {
		var option = document.createElement("option");
		option.value = result.data.kategorien[i].id;
		option.setAttribute("data-ignore", result.data.kategorien[i].ignore);
		option.innerHTML = result.data.kategorien[i].name;
		option.className = className;
		$("#"+select_id)[0].appendChild(option);
	}
}