md.fibu.newBuchung = function() {

	// Konten als Optionen an die Auswahl-Listen anhngen
	md.fibu.appendKontoOptions("new_buchung_konto_von", "new_buchung_konto_von_option");
	md.fibu.appendKontoOptions("new_buchung_konto_an", "new_buchung_konto_an_option");
	
	// Datum und Uhrzeit vorbelegen
	document.getElementById("new_buchung_datum").value = md.getCurrentDate();
	document.getElementById("new_buchung_zeit").value = md.getCurrentTime();
	
	// Kategorien als Optionen an die Auswahl-Liste anhngen
	md.fibu.appendKategorieOptions("new_buchung_kategorie", "new_buchung_kategorie_options");
	
	// Dialog anzeigen und zentrieren
	md.showAndCenter("new_buchung_dialog");
	
	// Name-Feld fokussieren
	document.getElementById("new_buchung_name").focus();
}
md.fibu.newBuchungSave = function() {

	var form = document.getElementById("new_buchung_form");
	
	// Daten ermitteln
	var konto_von = form.konto_von.value;
	var konto_an = form.konto_an.value;
	var name = form.name.value;
	var betrag = form.betrag.value;
	var datum = form.datum.value;
	var uhrzeit = form.zeit.value;
	var kategorie = form.kategorie.value;
	var description = form.description.value;
	
	// Url basteln
	var url = "ajax/submit_new_buchung.php";
	url += "?von_konto=" + encodeURIComponent(konto_von);
	url += "&an_konto=" + encodeURIComponent(konto_an);
	url += "&name=" + encodeURIComponent(name);
	url += "&betrag=" + encodeURIComponent(betrag);
	url += "&datum=" + encodeURIComponent(datum);
	url += "&zeit=" + encodeURIComponent(uhrzeit);
	url += "&kategorie=" + encodeURIComponent(kategorie);
	url += "&description=" + encodeURIComponent(description);
	
	// bertragen
	if(md.getValJsonObj(url) === false) {
		return;
	}

	$("#new_buchung_dialog").css("display", "none");
	md.fibu.refresh();
	form.reset();
}

md.fibu.editBuchung = function(id) {
	
	// Url basteln
	var url = "ajax/get_buchung.php";
	url += "?id=" + encodeURIComponent(id);
	
	// bertragen
	var result = md.getValJsonObj(url);
	if(result === false) {
		return false;
	}

	// Kategorie-Optionen an Select anhngen
	md.fibu.appendKategorieOptions("edit_buchung_kategorie", "edit_buchung_kategorie_options");
	
	// Formular befllen
	var data = result.data;
	var form = document.getElementById("edit_buchung_form");
	
	$("#edit_buchung_id").html(data.id);
	form.id.value = data.id;
	form.name.value = data.name;
	form.description.value = data.description;
	form.betrag.value = data.betrag;
	form.datum.value = data.datum;
	form.zeit.value = data.zeit;
	form.kategorie.value = data.kategorie;
	
	// Alten Betrag fr Warnung merken
	document.getElementById("edit_buchung_betrag").setAttribute("data-old", data.betrag);

	// Dialog anzeigen und zentrieren
	md.showAndCenter("edit_buchung_dialog");
}
md.fibu.editBuchungSubmit = function() {

	var form = document.getElementById("edit_buchung_form");
	
	// Prfen ob der Betrag gendert wurde und ggf. Warnung ausgeben
	if(document.getElementById("edit_buchung_betrag").getAttribute("data-old") != form.betrag.value) {
		if(!confirm("Wenn der Betrag gendert wird werden evtl. bestehende Verweise gelscht. Fortfahren?")) {
			return;
		}
	}
	
	// Daten ermitteln
	var id = form.id.value;
	var name = form.name.value;
	var betrag = form.betrag.value;
	var datum = form.datum.value;
	var uhrzeit = form.zeit.value;
	var kategorie = form.kategorie.value;
	var description = form.description.value;
	
	// Url basteln
	var url = "ajax/submit_edit_buchung.php";
	url += "?id=" + encodeURIComponent(id);
	url += "&name=" + encodeURIComponent(name);
	url += "&betrag=" + encodeURIComponent(betrag);
	url += "&datum=" + encodeURIComponent(datum);
	url += "&zeit=" + encodeURIComponent(uhrzeit);
	url += "&kategorie=" + encodeURIComponent(kategorie);
	url += "&description=" + encodeURIComponent(description);
	
	// bertragen
	if(md.getValJsonObj(url) === false) {
		return;
	}

	$("#edit_buchung_dialog").css("display", "none");
	md.fibu.refresh();
	form.reset();
}

md.fibu.deleteBuchung = function(id) {

	// Dialog anzeigen und zentrieren
	md.showAndCenter("delete_buchung_dialog");
	
	// Formular fllen
	var form = document.getElementById("delete_buchung_form");
	form.delete_buchung_id.value = id;
	$("#delete_buchung_name").html(id);
}
md.fibu.deleteBuchungSubmit = function() {
	var form = document.getElementById("delete_buchung_form");
	
	// Url basteln
	var url = "ajax/delete_buchung.php";
	url += "?id=" + encodeURIComponent(form.delete_buchung_id.value);
	
	// bertragen
	if(md.getValJsonObj(url) === false) {
		return;
	}
	
	$("#delete_buchung_dialog").css("display", "none");
	md.fibu.refresh();
	form.reset();
}